var usernameFieldsName = [
    'username', 'user name', 'email', 'email address', 'e-mail', 'e-mail address', 'userid', 'user id',
    'customer id', 'login id', 'identifier',
    'benutzername', 'benutzer name', 'email adresse', 'e-mail adresse', 'benutzerid', 'benutzer id'
];

function getUrlParameter(name) {
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};

function findUsernameField() {
    var usernameField;
    var inputs = document.getElementsByTagName('input');
    for (var i = 0; i < inputs.length; i++) {
        var inputType = inputs[i].type;
        if (inputType == 'email' || inputType == 'text' || inputType == 'tel') {
            var inputName = inputs[i].name;
            if (usernameFieldsName.indexOf(inputName > -1)) {
                usernameField = inputs[i];
            }
        }
    }
    return usernameField;
}

function findPasswordField() {
    var passwordField;
    var passwordElm = document.getElementById('password');
    if (passwordElm) {
        return passwordElm;
    }

    var inputs = document.getElementsByTagName('input');
    for (var i = 0; i < inputs.length; i++) {
        var inputType = inputs[i].type;
        if (inputType == 'password' || inputs[i].name == 'password') {
            passwordField = inputs[i];
            break;
        }
    }
    return passwordField;
}

function simulateInputChange(fieldValue, fieldElement) {
    var ev = new Event('input', { bubbles: true});
    ev.simulated = true;
    var lastValue = fieldElement.value;
    fieldElement.value = fieldValue;

    // React16 Hack for notifing value change
    let tracker = fieldElement._valueTracker;
    if (tracker) {
        tracker.setValue(lastValue);
    }

    fieldElement.dispatchEvent(ev);

     var nativeInputValueSetter = Object.getOwnPropertyDescriptor(window.HTMLInputElement.prototype, "value").set;
     nativeInputValueSetter.call(fieldElement, fieldValue);

     var ev2 = new Event('input', { bubbles: true });
     ev2.simulated = true;
     fieldElement.dispatchEvent(ev2);
}

function findStepButton() {
    var btnElement = document.querySelector('button');
    if (btnElement) {
        btnElement.onclick = function() {
            setTimeout(function(){
                executeAutoFill();
            }, 100);
        }
    }
}

function executeAutoFill() {
    var usernameField = findUsernameField();
    if (usernameField) {        
        simulateInputChange(getUrlParameter('u'), usernameField);
    }

    var passwordField = findPasswordField();
    if (passwordField) {
        simulateInputChange(getUrlParameter('p'), passwordField);
    } else {
        // Search for a next step button
        findStepButton();
    }
}

function documentReady(fn) {
    // see if DOM is already available
    if (document.readyState === "complete" || document.readyState === "interactive") {
        // call on next available tick
        setTimeout(fn, 450);
    } else {
        document.addEventListener("DOMContentLoaded", fn);
    }
}

documentReady(function() {
    executeAutoFill();
});



